bool cmd_parse() {

  for (int i = 0; i < server.args(); i++) {
    Serial.print(server.argName(i));
    Serial.print(" ");
    Serial.println(server.arg(i));
    int len = server.arg(i).length() + 1;
    char retour[20] = {0};
    server.arg(i).toCharArray(retour, len);

    if      (server.argName(i) == "format" && grandchef == true)    cmd_format();    //http://truc/cmd?format=""
    else if (server.argName(i) == "reset" && grandchef == true)     cmd_reset();     //http://truc/cmd?reset=""
    else if (server.argName(i) == "maj_heure" && grandchef == true) cmd_maj_heure(); //http://192.168.4.1/cmd?maj_heure=2018:08:16:18:39:00
    //else if (server.argName(i) == "ftpon" && grandchef == true)     cmd_ftpon();
    else if (server.argName(i) == "heure_ntp" && grandchef == true) heure_ntp();
    else if (server.argName(i) == "miseajour" && grandchef == true) cmd_sources_ailleurs(); // va chercher sur les sources
    else if (server.argName(i) == "info_conf" && grandchef == true) cmd_info_conf();
    else if (server.argName(i) == "info_wifi" && grandchef == true) cmd_info_wifi();
    else if (server.argName(i) == "passglob" ) {
      pass_global = server.arg(0);                                     //http://../cmd?passglob=lebonmotdepasse
      if (pass_global_config == pass_global) {
        grandchef = true;
        server.send(200, "text/plain", "admin");
        Serial.print("admin : ");
        Serial.println(pass_global);
      } else {
        server.send(200, "text/plain", "non");
      }
    }
    else if (server.argName(i) == "ssid" && grandchef == true)  {
      strncpy(conf_ssid , retour, len );
      Serial.println(conf_ssid);
      server.send(200, "text/plain", conf_ssid);
      ecrit == true;
    }
    else if (server.argName(i) == "pass" && grandchef == true) {
      strncpy(conf_pass , retour , len);
      Serial.println(conf_pass);
      server.send(200, "text/plain", conf_pass);
      ecrit == true;
    }
    else if (server.argName(i) == "canal" && grandchef == true) {
      conf_canal = atoi(retour);;
      Serial.println(conf_canal);
      ecrit == true;
    }
    else if (server.argName(i) == "ntpserv" && grandchef == true)  {
      strncpy(conf_serv_ntp , retour, len );
      Serial.println(conf_serv_ntp);
      server.send(200, "text/plain", conf_serv_ntp);
      ecrit == true;
    }
    else if (server.argName(i) == "sauve" && grandchef == true) {
      server.send(200, "text/plain", "sauve");
      Ecrit_config();
      Affiche_config();
      delay(200);
      ESP.restart();
      break;
    }
    else {
      server.send(500, "text/plain", "BAD ARGS http://truc/cmd?commande=... ");
      return false;
    }
  }
  return true;
}
void cmd_info_conf() {
  uint32_t realSize = ESP.getFlashChipRealSize();
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  String page = "serial_chip:" + (String)conf_id + "\n" ;
  page += "taille flash:" + (String)realSize + "\n";
  page += "version:" + (String)conf_version + "\n"  ;
  page += "ssid:" + (String)conf_ssid + "\n";
  page += "pass:" + (String)conf_pass + "\n";
  page += "pass_global:" + (String)conf_globpass + "\n" ;
  page += "nomhost: "    + (String)conf_nomhost + "\n";
  page += "site_ip:"     + (String)conf_site_ip + "\n" ;
  page += "horaire:"     + (String)conf_horaire + "\n" ;
  page += "ftp_user:"    + (String)conf_ftpuser + "\n" ;
  page += "ftp_pass:"    + (String)conf_ftppass + "\n" ;
  page += "source_ssid:" + (String)conf_source_ssid + "\n" ;
  page += "source_pass:" + (String)conf_source_pass + "\n" ;
  page += "source_url:"  + (String)conf_source_url + "\n" ;
  page += "source_dossier:" + (String)conf_source_dossier + "\n" ;
  page += "invisible:" + (String)conf_invisible + "\n" ;
  page += "canal:"     + (String)conf_canal + "\n" ;
  page += "max:"       + (String)conf_max + "\n" ;
  server.sendHeader("Content-Length", String(page.length()));
  server.send(200, "text/plain", page);
  //server.send(200, "text/plain", "");
  Affiche_config();
}
void cmd_info_wifi() {
}
void cmd_ftpon() {
  if (ftpon == false) {
    ftpSrv.begin(ftp_user, ftp_pass);   //username, password for ftp.  set ports in ESP8266FtpServer.h  (default 21, 50009 for PASV)
    ftpon = true;
    Serial.print("ftp on ");
    Serial.print(ftp_user);
    Serial.print(" : ");
    Serial.println(ftp_pass);
  }
}

bool cmd_format() {
  Serial.println(F("init formatage"));
  server.send(200, "text/html", "formatage 5min.." );
  SPIFFS.end();
  SPIFFS.format();// supprme tous les fichiers de la flash
  delay(1000);
  SPIFFS.begin();
  Serial.println(F("formatee"));
  uint32_t realSize = ESP.getFlashChipRealSize();
  String taille = "taille flash :";;
  taille += realSize;
  taille += " ok";
  server.sendHeader("Content-Length", String(taille.length()));
  server.send(200, "text/plain", taille);
}
bool cmd_reset() {
  Serial.println("reset");
  server.send(200, "text/html", "reset config pour relecture prtgeuse.json.." );
  SPIFFS.remove("/prtgeuse.json");
  delay(200);
  Relit_config();
  ecrit == true;
  Ecrit_config();
  Affiche_config();
  delay(200);
  ESP.restart(); // le premier restart ne fonctionne pas aprezs un flash, 1er reset a la main
}
// /fichier /////////// liste des fichier de la flash ////////////////////////
void fichierList() {
  long total = 0;
  int nbr = 0;
  uint32_t taillflash = ESP.getFlashChipRealSize();
  Dir dir = SPIFFS.openDir("/");
  String output = "";
  output += "ID: " + (String)CHIP_ID + "\n";
  output += "fichiers:\n";
  while (dir.next()) {
    String fileName = dir.fileName();
    size_t fileSize = dir.fileSize();
    total += fileSize;
    nbr += 1;
    output += fileName + " " + fileSize + "\n";
    Serial.printf("FS File: % s, size: % s\n", fileName.c_str(), formatBytes(fileSize).c_str());
  }
  output += "\n" + (String)nbr + " fichiers ";
  output += (String)total  + " sur " + (String)taillflash + "\n";
  Serial.println(output);
  server.sendHeader("Content-Length", String(output.length()));
  server.send(200, "text/plain", output);
}
bool cmd_maj_heure() {
  String bonneheure = server.arg("maj_heure");
  Serial.println(decoupe(bonneheure, ':', 3));
  Serial.println(decoupe(bonneheure, ':', 4));
  Serial.println(decoupe(bonneheure, ':', 5));

  int an = decoupe(bonneheure, ':', 0).toInt();
  int mo = decoupe(bonneheure, ':', 1).toInt();
  int jo = decoupe(bonneheure, ':', 2).toInt();
  int heure = decoupe(bonneheure, ':', 3).toInt();
  int minut = decoupe(bonneheure, ':', 4).toInt();
  int sec   = decoupe(bonneheure, ':', 5).toInt();
  String output = (String)an + " " + (String)mo + " " + (String)jo + " " + (String)heure + " " + (String)minut + " " + (String)sec + "\n";
  server.sendHeader("Content-Length", String(output.length()));
  server.send(200, "text / plain", output);
  Serial.println(heure);
  Serial.println(minut);
  Serial.println(sec);
  Serial.println(output);
  setTime(heure, minut, sec, jo, mo, an);
  //rtc.adjust(DateTime(an, mo, jo, heure, minut, sec));
  String maintenant = "date: " + (String)DonneDate();
  Serial.print("date ");
  Serial.println(maintenant);

  server.sendHeader("Content-Length", String(maintenant.length()));
  server.send(200, "text/plain", maintenant);
}

