char conf_json[] = "{\"serial_chip\":0,\"version\":1,\"ssid\":\"PARTAGEOIR\",\"pass\":\"\",\"pass_global\":\"gnulinux\",\"nomhost\":\"http://192.168.4.1\",\"site_ip\":\"192.168.4.1\",\"horaire\":\"9 10 11 12 13 14 15 16 17 18 19 20 21 22 23\",\"ftp_user\":\"toto\",\"ftp_pass\":\"linux\",\"source_ssid\":\"PARTAGEUSE\",\"source_pass\":\"1234567890\",\"source_url\":\"http://insitu.site/public\",\"source_dossier\":\"defaut\",\"invisible\":0,\"canal\":6,\"max\":6}";

////////// fichiers de configuration .txt ////////////////////////

// on extrait prtgeuse.txt du fichier param ex prtgeuse.txt /////////
/// ce .txt sera ré ecrit en .json
int Recup_config(void) {

  Serial.println(F("recup config"));
  int i = 0;
  int buffer_lenght = 0;
  int line_counter = 0 ;
  bool bon_chip = false;
  bool chipok = false;
  char buff[81], *key, *value;
  for (int i = 0; i < 80; i++) buff[i] = 'NULL';
  delay(100);
  // recherche fichier prtgeuse.txt pour y prendre des choses
  File param_file = SPIFFS.open("/prtgeuse.txt", "r");
  if (param_file) {
    Serial.println(F("lecture prtgeuse.txt"));

    while (param_file.available() > 0) {
      i = 0;
      while ((buff[i++] = param_file.read()) != '\n') {
        /* Si la ligne dépasse la taille du buffer */
        if (i == BUFFER_SIZE) {
          /* On finit de lire la ligne mais sans stocker les données */
          while (param_file.read() != '\n');
          break; // Et on arrête la lecture de cette ligne
        }
        Serial.println(buff[i - 1]);

      }
      buffer_lenght = i;

      /* Gestion des lignes trop grande */
      if (i == BUFFER_SIZE) {
        Serial.println(F("Ligne trop longue à la ligne "));
        Serial.println(line_counter, DEC);
        Serial.println(i);
      }
      /* Finalise la chaine de caractéres ASCIIZ en supprimant le \n au passage */
      buff[--i] = '\0';
      /* Incrémente le compteur de lignes */
      ++line_counter;
      /* Ignore les lignes vides ou les lignes de commentaires */
      if (buff[0] == '\0' || buff[0] == '#') continue;
      /* Cherche l'emplacement de la clef en ignorant les espaces et les tabulations en début de ligne */
      i = 0;
      while (buff[i] == ' ' || buff[i] == '\t') {
        if (++i == buffer_lenght) break; // Ignore les lignes contenant uniquement des espaces et/ou des tabulations
      }
      if (i == buffer_lenght) continue; // Gère les lignes contenant uniquement des espaces et/ou des tabulations
      key = &buff[i];
      /* Cherche l'emplacement du séparateur = en ignorant les espaces et les tabulations âpres la clef */
      while (buff[i] != '=') {
        /* Ignore les espaces et les tabulations */
        if (buff[i] == ' ' || buff[i] == '\t') buff[i] = '\0';
        if (++i == buffer_lenght) {
          Serial.println(F("Ligne mal forme a la ligne "));
          Serial.println(line_counter, DEC);
          break; // Ignore les lignes mal formé
        }
      }
      if (i == buffer_lenght) continue; // Gère les lignes mal formé
      /* Transforme le séparateur = en \0 et continue */
      buff[i++] = '\0';
      /* Cherche l'emplacement de la valeur en ignorant les espaces et les tabulations âpres le séparateur */
      while (buff[i] == ' ' || buff[i] == '\t') {
        if (++i == buffer_lenght) {
          Serial.println(F("Ligne mal forme a la ligne "));
          Serial.println(line_counter, DEC);
          break; // Ignore les lignes mal formé
        }
      }
      if (i == buffer_lenght) continue; // Gère les lignes mal formé
      value = &buff[i];

      Serial.print(key);
      Serial.print(F(" : "));
      Serial.print(value);

      /* Transforme les données texte en valeur utilisable */

      if (strcmp(key, "GLOBPASS") == 0 && bon_chip == true) strlcpy(conf_globpass , value , sizeof(conf_globpass));
      else if (strcmp(key, "SOURCE_SSID") == 0)  strlcpy(conf_source_ssid , value , sizeof(conf_source_ssid));
      else if (strcmp(key, "SOURCE_PASS") == 0)  strlcpy(conf_source_pass , value , sizeof(conf_source_pass));
      else if (strcmp(key, "SOURCE_SITE") == 0)  strlcpy(conf_source_url  , value , sizeof(conf_source_url));

      else if (strcmp(key, "DOSSIER") == 0 && bon_chip == true)  {
        repertoire = value ;
        strlcpy(conf_source_dossier, value , sizeof(conf_source_dossier));
        Serial.println(F("OK DOSSIER "));
        Serial.println(repertoire);
      }
      else if (strcmp(key, "SSID") == 0 && bon_chip == true)     strlcpy(conf_ssid     , value  , sizeof(conf_ssid));
      else if (strcmp(key, "PASS") == 0 && bon_chip == true)     strlcpy(conf_pass     , value  , sizeof(conf_pass));
      else if (strcmp(key, "SITE") == 0 && bon_chip == true)     strlcpy(conf_nomhost  , value  , sizeof(conf_nomhost));
      else if (strcmp(key, "GLOBPASS") == 0 && bon_chip == true) strlcpy(conf_globpass , value  , sizeof(conf_globpass));
      else if (strcmp(key, "FTPUSER") == 0 && bon_chip == true)  strlcpy(conf_ftpuser  , value  , sizeof(conf_ftpuser));
      else if (strcmp(key, "FTPPASS") == 0 && bon_chip == true)  strlcpy(conf_ftppass  , value  , sizeof(conf_ftppass));
      else if (strcmp(key, "SERVNTP") == 0 && bon_chip == true)  strlcpy(conf_serv_ntp , value  , sizeof(conf_serv_ntp));
      else if (strcmp(key, "SITEIP") == 0 && bon_chip == true)  {
        if (isIp(value)) {
          char buf[25] = "";
          strcpy(buf, &buff[i]);
          byte ip[4] = {0};
          char * item = strtok(buf, ".");
          uint8_t index = 0;
          while (item != NULL) {
            if ((*item >= '0') && (*item <= '9')) {
              ip[index++] = atoi(item);
              Serial.print(item);
              Serial.print(F(" "));
            }
            item = strtok(NULL, ".");
          }
          strlcpy(conf_site_ip, value, sizeof(conf_site_ip));
          serveurIP =  IPAddress( ip[0], ip[1], ip[2], ip[3]);
        }
      }
      else if (strcmp(key, "VERSION") == 0 && bon_chip == true)        conf_version       = atoi(value);
      else if (strcmp(key, "CANAL") == 0 && bon_chip == true)          canal_wifi         = atoi(value);
      else if (strcmp(key, "MAX_CONNEXION") == 0 && bon_chip == true)  conf_max           = atoi(value);
      else if (strcmp(key, "INVISIBLE") == 0 && bon_chip == true)      conf_invisible     = atoi(value);
      else if (strcmp(key, "HORAIRES") == 0 && bon_chip == true)       strlcpy(conf_horaire , value , sizeof(conf_horaire));
      else if (strcmp(key, "CHIP_ID") == 0) {  // bon serial
        if ( atoi(value) == CHIP_ID && bon_chip == true) {
          /* Ferme le fichier de configuration */
          param_file.close();
          delay(200);
          Ecrit_config();
          Relit_config();
          Serial.println(F("fin fin"));
          return 0;
        }
        if ( atoi(value) == CHIP_ID ) {
          bon_chip = true;
        } else {
          bon_chip = false;
        }
      }
      else { // Default
        Serial.print(F(" Clef inconnu "));
        Serial.println(key);
      }
      key = "";
      value = "";
      Serial.println(F(""));
    }
    /* Ferme le fichier de configuration */
    param_file.close();
    delay(200);
    Ecrit_config();
    delay(200);
    ecrit = true;
    Relit_config();
    Serial.println(F("fin "));
  } else {
    Serial.print(F("pas de fichier de config.txt "));
  }
}

bool Ecrit_config() {
  Serial.println(F("ecrit prtgeuse.json"));
  delay(200);
  File config_file = SPIFFS.open("/prtgeuse.json", "w");
  StaticJsonBuffer<2048> jsonBuffer;
  JsonObject &root = jsonBuffer.createObject();
  if (conf_id == 0) { // premier passage
    conf_id = CHIP_ID ;
    conf_version = 0 ;
    strlcpy(conf_ssid, def_ssid, sizeof(conf_ssid));
    strlcpy(conf_pass, def_pass, sizeof(conf_pass));
    strlcpy(conf_globpass, def_globpass, sizeof(conf_globpass));
    strlcpy(conf_nomhost, def_nomhost, sizeof(conf_nomhost));
    strlcpy(conf_site_ip, def_site_ip, sizeof(conf_site_ip));
    strlcpy(conf_horaire, def_horaire, sizeof(conf_horaire));
    strlcpy(conf_serv_ntp, def_serv_ntp, sizeof(conf_serv_ntp));
    strlcpy(conf_ftpuser, def_ftpuser, sizeof(conf_ftpuser));
    strlcpy(conf_ftppass, def_ftppass, sizeof(conf_ftppass));
    strlcpy(conf_source_ssid, def_source_ssid, sizeof(conf_source_ssid));
    strlcpy(conf_source_pass, def_source_pass, sizeof(conf_source_pass));
    strlcpy(conf_source_dossier, def_source_dossier, sizeof(conf_source_dossier));
    conf_invisible = invisible;
    conf_canal = canal_wifi;
    conf_max = max_connexion;
  }
  root["serial_chip"]    = conf_id;
  root["version"]        = conf_version;
  root["ssid"]           = strdup(conf_ssid);
  root["pass"]           = strdup(conf_pass);
  root["pass_global"]    = strdup(conf_globpass);
  root["nomhost"]        = strdup(conf_nomhost);
  root["site_ip"]        = strdup(conf_site_ip);
  root["horaire"]        = strdup(conf_horaire);
  root["serv_ntp"]        = strdup(conf_serv_ntp);
  root["ftp_user"]       = strdup(conf_ftpuser);
  root["ftp_pass"]       = strdup(conf_ftppass);
  root["source_ssid"]    = strdup(conf_source_ssid);
  root["source_pass"]    = strdup(conf_source_pass);
  root["source_url"]     = strdup(conf_source_url);
  root["source_dossier"] = strdup(conf_source_dossier);
  root["invisible"]      = conf_invisible;
  root["canal"]          = conf_canal;
  root["max"]            = conf_max;
  Serial.println(F("ecrit prtgeuse.json"));
  root.printTo(Serial);
  Serial.println("");
  delay(200);
  if (root.printTo(config_file) == 0) {
    Serial.println(F("pb ecriture prtgeuse"));
  }
  Serial.println(F("fin json"));
  config_file.close();
  delay(200);
}
bool Relit_config() {
  delay(200);
  Serial.println(F("relit prtgeuse.json"));

  File config_file = SPIFFS.open("/prtgeuse.json", "r");
  if (!config_file) {
    Serial.println(F("inititialisation prtgeuse.json"));
    config_file = SPIFFS.open("/prtgeuse.json", "w");
    config_file.print(conf_json);
    config_file.close();
    delay(200);
    config_file = SPIFFS.open("/prtgeuse.json", "r");
  }
  StaticJsonBuffer<2048> jsonBuffer;
  JsonObject &root = jsonBuffer.parseObject(config_file);

  if (!root.success()) {
    Serial.println(F("pb lecture prtgeuse.json"));
    return false;
  }
  /////////
  conf_id             = atoi(root["serial_chip"]);
  if (conf_id != CHIP_ID) {
    Serial.println(F("chip id different de serial_chip, maj"));
    conf_id = CHIP_ID;
  }
  conf_version        = atoi( root["version"]);
  strlcpy(conf_ssid           , root["ssid"]        , sizeof(conf_ssid));
  strlcpy(conf_pass           , root["pass"]        , sizeof(conf_pass));
  strlcpy(conf_globpass       , root["pass_global"] , sizeof(conf_globpass));
  strlcpy(conf_nomhost        , root["nomhost"]     , sizeof(conf_nomhost));
  strlcpy(conf_site_ip        , root["site_ip"]     , sizeof(conf_site_ip));
  strlcpy(conf_horaire        , root["horaire"]     , sizeof(conf_horaire));
  strlcpy(conf_serv_ntp        , root["serv_ntp"]     , sizeof(conf_serv_ntp));
  conf_invisible      = atoi(root["invisible"]);
  conf_canal          = atoi(root["canal"]);
  conf_max            = atoi(root["max"]) ;
  strlcpy(conf_ftpuser        , root["ftp_user"]      , sizeof(conf_ftpuser));
  strlcpy(conf_ftppass        , root["ftp_pass"]      , sizeof(conf_ftppass));
  strlcpy(conf_source_ssid    , root["source_ssid"]   , sizeof(conf_source_ssid));
  strlcpy(conf_source_pass    , root["source_pass"]   , sizeof(conf_source_pass));
  strlcpy(conf_source_url     , root["source_dossier"], sizeof(conf_source_url));
  config_file.close();
  delay(200);
  return true;
}
////////////////::

bool Affiche_config() {
  File config_file = SPIFFS.open("/prtgeuse.json", "r");
  if (!config_file) {
    Serial.println(F("inititialisation /prtgeuse.json"));
    config_file = SPIFFS.open("/prtgeuse.json", "w");
    config_file.print(conf_json);
    config_file.close();
    delay(200);
    config_file = SPIFFS.open("/prtgeuse.json", "r");
  }
  Serial.println(F("afiche /prtgeuse.json"));
  while (config_file.available() > 0) {
    Serial.print(char(config_file.read()));
  }
  Serial.println(F(""));
  config_file.close();
  delay(200);
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  String page = "serial_chip:" + (String)conf_id + "\n" ;
  page += "version:" + (String)conf_version + "\n"  ;
  page += "ssid:" + (String)conf_ssid + "\n";
  page += "pass:" + (String)conf_pass + "\n";
  page += "pass_global:" + (String)conf_globpass + "\n" ;
  page += "nomhost: "    + (String)conf_nomhost + "\n";
  page += "site_ip:"     + (String)conf_site_ip + "\n" ;
  page += "horaire:"     + (String)conf_horaire + "\n" ;
  page += "serv_ntp:"     + (String)conf_serv_ntp + "\n" ;
  page += "ftp_user:"    + (String)conf_ftpuser + "\n" ;
  page += "ftp_pass:"    + (String)conf_ftppass + "\n" ;
  page += "source_ssid:" + (String)conf_source_ssid + "\n" ;
  page += "source_pass:" + (String)conf_source_pass + "\n" ;
  page += "source_url:"  + (String)conf_source_url + "\n" ;
  page += "source_dossier:" + (String)conf_source_dossier + "\n" ;
  page += "invisible:" + (String)conf_invisible + "\n" ;
  page += "canal:"     + (String)conf_canal + "\n" ;
  page += "max:"       + (String)conf_max + "\n" ;
  server.sendHeader("Content-Length", String(page.length()));
  server.send(200, "text/plain", page);
  //server.send(200, "text/plain", "");

  Serial.println(page);
  Serial.println(F(""));

  return true;
}

