////////// télécharge les fichiers de la partageuse //////////////
int Recup_Pages(String page) {
  String url;
  if (repertoire.length() <= 1 ) url = http_site + "/" + page; //listfic.txt forme /fichier.truc
  else url = http_site +  "/" + repertoire + "/" + page;
  Serial.println(url);
  HTTPClient http;
  http.begin(url);
  //http.begin("http://192.168.4.1/prtgeuse.txt") ;
  //http.begin("http://192.168.4.1/DOSSIER/index.html") ;
  //http.begin("http://192.168.4.1/DOSSIER/listfic.txt") ;
  int httpCode = http.GET();
  if (httpCode > 0) {
    //fichiers et serveur trouvés
    // HTTP header has been send and Server response header has been handled
    Serial.printf("[HTTP] GET... code:%d\n", httpCode);
    if (httpCode == HTTP_CODE_OK || httpCode == -5) {
      // get lenght of document (is -1 when Server sends no Content-Length header)
      int len = http.getSize();
      // create buffer for read
      uint8_t buff[128] = { 0 };
      // get tcp stream
      fsUploadFile = SPIFFS.open(page, "w"); //
      WiFiClient * stream = http.getStreamPtr();
      // read all data from server
      while (http.connected() && (len > 0 || len == -1)) {
        // get available data size
        size_t size = stream->available();
        if (size) {
          // read up to 128 byte
          int c = stream->readBytes(buff, ((size > sizeof(buff)) ? sizeof(buff) : size));
          //Serial.write(buff, c);
          fsUploadFile.write(buff, c);
          if (len > 0) {
            len -= c;
          }
        }
        delay(1);
      }
      //Serial.println();
      fsUploadFile.flush();
      fsUploadFile.close();
      delay(1000);
      if (SPIFFS.exists(page)) {
        fsUploadFile = SPIFFS.open(page, "r");
        Serial.print(page);
        Serial.print(F(" fait "));
        Serial.println(fsUploadFile.size());
        fsUploadFile.close();
      }
      Serial.print(F("[HTTP] connection closed or file end.\n"));
      http.end();
      return 0;
    }
  } else {
    Serial.printf("[HTTP] GET... failed, error:%s\n", http.errorToString(httpCode).c_str());
    http.end();
    return 1;
  }
  http.end();
  return 1;
}
/////////////// sources //////////////////
bool cmd_sources_ailleurs() {
  //WIFI connexion aux pages sources
  WiFi.disconnect();
  Serial.print(F("Connexion aux sources..."));
  Serial.print(ssid_biblio);
  Serial.print(password_biblio);

  WiFi.mode(WIFI_STA);
  delay(1000);
  WiFi.begin(ssid_biblio, password_biblio);
  essai_connexion = 0;
  while ( WiFi.status() != WL_CONNECTED ) {
    Serial.print(F("."));
    if (essai_connexion++ >= 5) return false; // on sort au bout de 5 s
    delay(1000);
  }
  Serial.println(WiFi.localIP());
  delay(1000);
  Mise_a_jour();
  WiFi.disconnect();
}
////////// mise a jour des pages /////////////////////
void Mise_a_jour() { // mise a jour de la flash
  Serial.println(F("mise a jour"));
  delay(100);
  Recup_config(); // donne un param_version si existe avant recup
  param_version_flash = param_version;
  repertoire = ""; // fixe repertoire a la racine
  // re recupere fichier de parametres
  Serial.println(F("telecharge /prtgeuse.txt"));

  for (int i = 0; i < 5; i++) {
    essai_connexion = Recup_Pages("/prtgeuse.txt");
    if (essai_connexion == 0 ) {
      Serial.println(F("prtgeuse.txt ok"));
      break;
    }
    delay(1000);
  }
  if (SPIFFS.exists("/prtgeuse.txt")) {
    Recup_config(); // pour trouver bon repertoire et param_version
    //// MAINTENANT Recup_Pages prend dans repertoire !! ////////////////
    Serial.print(param_version_flash);
    Serial.print(" ");
    Serial.println(param_version);
    if (param_version_flash != param_version || param_version_flash == 0) {
      Serial.print(F("VERSION differentes "));
      // mise a bonheure ?
      if ( bonheure.length() > 1) {
        //rtc.adjust(DateTime(bonheure));
      }
      // recupere liste des fichiers a recuperer
      for (int i = 0; i < 5; i++) {
        essai_connexion = Recup_Pages("/listfic.txt");
        if (essai_connexion == 0 ) break;
        delay(1000);
      }
      list_file = SPIFFS.open("/listfic.txt", "r");
      if (list_file) {
        String buffer;
        while (list_file.available() > 0 ) { // nbr_fic de ligne de list_file
          buffer = list_file.readStringUntil('\n');
          if ( buffer != "/listfic.txt" ) Recup_Pages( buffer);
          nbr_fic++;
        }
        list_file.close();
      } else {
        Serial.println(F("pb ouverture listfic.txt"));
      }
    } else {
      Serial.print(F("VERSION identique"));
    }
  } else {
    Serial.println(F("pas de /prtgeuse.txt"));
  }
}
