/*
  Page par défaut du portail captif

  const char HTTP_HEAD[] PROGMEM     = "<!DOCTYPE html><html lang=\"en\"><head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1, user-scalable=no\"/><title>{v}</title>";
  const char HTTP_STYLE[] PROGMEM    = "<style>.c{text-align: center;} div,input{padding:5px;font-size:1em;} input{width:95%;} body{text-align: center;font-family:verdana;} button{border:0;border-radius:0.3rem;background-color:#1fa3ec;color:#fff;line-height:2.4rem;font-size:1.2rem;width:100%;} .q{float: right;width: 64px;text-align: right;} .l{background: url(\"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAMAAABEpIrGAAAALVBMVEX///8EBwfBwsLw8PAzNjaCg4NTVVUjJiZDRUUUFxdiZGSho6OSk5Pg4eFydHTCjaf3AAAAZElEQVQ4je2NSw7AIAhEBamKn97/uMXEGBvozkWb9C2Zx4xzWykBhFAeYp9gkLyZE0zIMno9n4g19hmdY39scwqVkOXaxph0ZCXQcqxSpgQpONa59wkRDOL93eAXvimwlbPbwwVAegLS1HGfZAAAAABJRU5ErkJggg==\") no-repeat left center;background-size: 1em;}</style>";
  const char HTTP_SCRIPT[] PROGMEM   = "<script>function c(l){document.getElementById('s').value=l.innerText||l.textContent;document.getElementById('p').focus();}</script>";
  const char HTTP_HEAD_END[] PROGMEM = "</head><body><div style='text-align:left;display:inline-block;min-width:260px;'>";
  const char HTTP_END[] PROGMEM      = "</div></body></html>";
  const char HTTP_FORM_END[] PROGMEM        = "<br/><button type='submit'>save</button></form>";
  const char HTTP_PORTAL_OPTIONS[] PROGMEM  = "<form action=\"/index.html\" method=\"get\"><button>Entrez</button></form><br/>";
*/
void affiche_page_portail() {
  if (!SPIFFS.exists("portail.html")) {
    String page_html = "<!DOCTYPE html><html lang=\"en\"><head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1, user-scalable=no\"/><title>{v}</title>";
    page_html.replace("{v}", "Entr&eacute;e");
    page_html += "<script>function c(l){document.getElementById('s').value=l.innerText||l.textContent;document.getElementById('p').focus();}</script>";
    page_html += "<style>.c{text-align: center;} div,input{padding:5px;font-size:1em;} input{width:95%;} body{text-align: center;font-family:verdana;} button{border:0;border-radius:0.3rem;background-color:#1fa3ec;color:#fff;line-height:2.4rem;font-size:1.2rem;width:100%;} .q{float: right;width: 64px;text-align: right;} .l{background: url(\"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAMAAABEpIrGAAAALVBMVEX///8EBwfBwsLw8PAzNjaCg4NTVVUjJiZDRUUUFxdiZGSho6OSk5Pg4eFydHTCjaf3AAAAZElEQVQ4je2NSw7AIAhEBamKn97/uMXEGBvozkWb9C2Zx4xzWykBhFAeYp9gkLyZE0zIMno9n4g19hmdY39scwqVkOXaxph0ZCXQcqxSpgQpONa59wkRDOL93eAXvimwlbPbwwVAegLS1HGfZAAAAABJRU5ErkJggg==\") no-repeat left center;background-size: 1em;}</style>";
    page_html += "</head><body><div style='text-align:left;display:inline-block;min-width:260px;'>";
    page_html += "<h1>Ceci est un portail captif</h1>";
    //page_html += String(F("<h3>WiFiManager</h3>"));
    page_html += "<form action=\"http://" ;
    page_html += toStringIp(server.client().localIP()) ;//WiFi.softAPIP() ;
    page_html += "/index.html\" method=\"get\"><button>Entrez</button></form><br/>";
    page_html += "<br/><br/><br/>connexion:";
    page_html += WiFi.softAPgetStationNum();
    page_html += "  sur 5 max.";
    page_html += "<br/>D&eacute;connectez vous du WiFi d&egrave;s que vous le pouver afin de laisser de la place";
    page_html += "<br/><br/>Vous ne serez pas connect&eacute; sur Internet.";
    page_html += "<br/>Vous ne serez pas trac&eacute;.";
    page_html += "<br/>Les 'partageoirs' sont des projets artistiques de l'association SNHack.";
    page_html += "<br/>Ce sont des outils libres d'&eacute;dition et de diffusion WiFi in situ.";
    page_html += "<br/><br/>";
    page_html += DonneDate();
    page_html += "<br/>";

    page_html += "</head><body><div style='text-align:left;display:inline-block;min-width:260px;'></div></body></html>";
    //Serial.println("+");

    server.sendHeader("Content-Length", String(page_html.length()));
    server.send(200, "text/html", page_html);
  }
}
/////////////////////// trucs web ///////////////////////////////////////::
/** Redirect to captive portal if we got a request for another domain. Return true in that case so the page handler do not try to handle the request again. */
boolean captivePortal() {
  //Serial.println(server.hostHeader());

  if (!isIp(server.hostHeader()) && server.hostHeader() != (String(nomssid) + ".local")) {
    Serial.print("Request redirected to captive portal");
    server.sendHeader("Location", String("http://") + toStringIp(server.client().localIP()), true);
    server.send ( 302, "text/plain", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
    server.client().stop(); // Stop is needed because we sent no content length
    return true;
  }
  return false;
}
