void heure_rtc() {
  Rtc.Begin();
  Serial.println(F("RTC begin"));
  if (!Rtc.IsDateTimeValid())
  {
    RtcDateTime compiled = RtcDateTime(__DATE__, __TIME__);
    Serial.println(F("RTC set compiled"));
    Rtc.SetDateTime(compiled);
  }
  if (!Rtc.GetIsRunning())
  {
    Serial.println(F("RTC was not actively running, starting now"));
    Rtc.SetIsRunning(true);
  }
  Serial.println(F("RTC get time"));
  Serial.println(F("RTC ok"));
  RtcDateTime now = Rtc.GetDateTime();
  setTime(now.Hour(), now.Minute(), now.Second(), now.Day(), now.Month(), now.Year());
}
void mise_a_jour_rtc( time_t bonheure) { // mise a jour de l'horloge , temps ntp
  Rtc.Begin();
  if (!Rtc.IsDateTimeValid())
  {
    RtcDateTime compiled = RtcDateTime(__DATE__, __TIME__);
    Rtc.SetDateTime(compiled);
  }
  if (!Rtc.GetIsRunning())
  {
    Serial.println(F("RTC was not actively running, starting now"));
    Rtc.SetIsRunning(true);
  }
  Rtc.SetDateTime(bonheure);
 
}
////////////// DATE PRINT //////////////////////////////
#define countof(a) (sizeof(a)/sizeof(a[0]))
String DonneDate()
{
  char datestring[20];
  snprintf_P(datestring,
             countof(datestring),
             PSTR("%04u/%02u/%02u %02u:%02u:%02u"),  // date linux date -s "2018/05/18 15:54:00"
             year(),
             month(),
             day(),
             hour(),
             minute(),
             second() );
  //Serial.print(datestring);
  return datestring;
}
/////////////// test horaire ////////////////////

void Test_horaires() {   // cherche si heure maintenant contenue dans horaires
  Serial.println(F("test horaire"));
  //Serial.println(conf_horaire);

  int heure = 0 ;
  int taille_plages = strlen(conf_horaire);
  //Serial.println(taille_plages);

  if (taille_plages > 3 ) {
    char buf[3] = "00";
    for (int i = 0; i < taille_plages; i++) {
      buf[0] = conf_horaire[i++];
      if (conf_horaire[i] != ',' && conf_horaire[i] != ';' && conf_horaire[i] != ' ') buf[1] = conf_horaire[i++];
      else buf[1] = '\0';
      buf[2] = '\0';
      heure = atoi(buf);
      if ( heure == hour() ) {
        heure = 99;
        break;
      }
    }
    int reste = 58 - minute();
    if (reste > 3 && heure < 90) {
      ESP.deepSleep(1000000 * 60 * (uint64_t)reste);
    }
  } else Serial.println(F("ok"));
}
//////////////////////////////////////////////////
// Sauvegarde de la date pour les DeepSleep ??
// au redemarrage on ajoute le temps du deepsleep pour retrouver la date
